#!/usr/bin/python
#!@PYTHON@

#  TODO: center option

# log:

# 0.3:
#   rewrite in Python.
#
# I have tries to improve mudela-book to fit my needs when I am writing
# my thesis about ear training. As I to not know other os or latex than
# Debian and tetex from debian, there is NO garantee the output will look
# nice on other systems.
#
# I have tries do steal as much as possible from ly2dvi32.py, since the
# author knows a lot more programming and python than I.

import os
import string
import re
import getopt
import sys
import regsub

outdir = 'out/'
program_version = '0.3'

default_paper_size_global = 'a4'
default_mudela_fontsize = '16pt'
force_mudela_fontsize_b = 0

fontsize_i2a = {11:'eleven', 13:'thirteen', 16:'sixteen', 20:'twenty', 26:'twentysix'}
fontsize_pt2i = {'11pt':11, '13pt':13, '16pt':16, '20pt':20, '26pt':26}


def file_exist_b(name):
    try: 
	f = open(name)
    except IOError:
	return 0
    f.close ()
    return 1

def ps_dimention(fname):
    fd = open(fname)
    lines = fd.readlines()
    reg = re.compile('%%BoundingBox: ([0-9]*) ([0-9]*) ([0-9]*) ([0-9]*)')
    for line in lines:
        s = reg.search(line)
        if s:
            break
    return (int(s.groups()[2])-int(s.groups()[0]), 
            int(s.groups()[3])-int(s.groups()[1]))

class PaperDef:
    __onecolumn_linewidth = {
            'a4':360,
            'a5':276,
            'b5':356,
            'letter':360,
            'legal':360,
            'executive':360
            }
    __twocolumn_linewidth = {
            'a4':175,
            'a5':133,
            'b5':173,
            'letter':174,
            'legal':174,
            'executive':175
            }
    __numcolumn = 1
    #
    # init
    #
    def __init__(self):
        self.__papersize = default_paper_size_global
    def set_papersize (self, p):
        if not self.__onecolumn_linewidth.has_key(p):
            print "warning:unsupported papersize", p, \
                  "will use", default_paper_size_global
            self.__papersize = default_paper_size_global
        else:
            self.__papersize = p
    def get_linewidth (self):
        if self.__numcolumn == 1:
            return self.__onecolumn_linewidth[self.__papersize]
        else:
            return self.__twocolumn_linewidth[self.__papersize]
    def twocolumn (self):
        self.__numcolumn = 2
class CompileStatus:
    pass

def file_mtime (name):
    return os.stat (name)[8] #mod time
#
# executes os.system(command) if infile is newer than
# outfile or outfile don't exist
#
def compile (command, infile, outfile):
    indate = file_mtime (infile)
    try:
        outdate = file_mtime (outfile)
        recompile = indate > outdate

    except os.error:
        recompile = 1

    if recompile:
        sys.stderr.write ('invoking `%s\'\n' % command)
		
        status = os.system (command)
        if status:
            raise CompileStatus

class Mudela_output:
    def __init__ (self):
        self.basename = ''
        self.fragment = 0
        self.charps = 0
        self.size = fontsize_pt2i[default_mudela_fontsize]
    def open_to_create_ps(self, basename):
        self.charps = 1
        self.open(basename)
    def open (self, basename):
        self.basename = basename
        self.temp_file = "%s/%s" %(outdir, 'mudela-temp.ly')
        self.file = open (self.temp_file, 'w')
        self.file.write ('\\include \"paper%d.ly\"\n' % self.size)
        s = fontsize_i2a[self.size]
        if self.fragment:
            self.file.write("default_paper = \\paper {"
                            + "\\paper_%s\n linewidth = -1.\\pt;" % s
                            + "castingalgorithm = \Wordwrap; \n")
        else:
            self.file.write ("default_paper = \\paper {"
                             + "\\paper_%s\n linewidth = %i.\\pt;" % \
                             (s, Paper.get_linewidth()) \
                             + "castingalgorithm = \Wordwrap; \n")
        self.file.write("}\n")
		
        if self.fragment:
            self.file.write ('\\score { \\notes { ')

    def write (self,s):
        self.file.write (s)

    def close (self):
        if self.fragment:
            self.file.write ('}\n \\paper { \\default_paper; } }\n')
        self.file.close ()

        inf=self.basename + '.ly'
        outf = self.basename + '.tex'		
        if not file_exist_b (inf):
            status = 1
        else:
#print 'invoking %s' %('diff %s %s' % (self.temp_file, inf))
            status = os.system ('diff -q %s %s' % (self.temp_file, inf))
#print 'status %d' % status

        if status:
            os.rename (self.temp_file, inf)
        compile ('lilypond  -o %s %s;'%  (self.basename, inf), inf, outf)
        if self.charps:
            tex_name = self.basename+'.tex'
            dvi_name = self.basename+'.dvi'
            dvi_stripped_name = dvi_name[string.rfind(dvi_name, '/')+1:]
            ps_name = self.basename+'.ps'
            compile ('tex %s' % tex_name, tex_name, dvi_name)
            os.system('mv %s %s' % (dvi_stripped_name, dvi_name))
            compile ('dvips -E -o %s %s' % (ps_name, dvi_name), dvi_name, ps_name)
#			os.rename (self.basename + '.tex', outdir  +)
		
	

class Tex_output:
    def __init__ (self, name):
        self.output_fn = '%s/%s' % (outdir, name)
        self.file = open (self.output_fn , 'w')
        self.verbatim = 0
        self.charps = 0
    def open_mudela (self, basename):
        self.mudela_basename = basename
    def open_to_include_ps (self, basename):
        self.charps = 1
        self.mudela_basename = basename
    def open_verbatim (self):
        self.verbatim = 1
        self.file.write ('\\begin{verbatim}\n')
    def write (self, s):
        self.file.write (s)
			
#    def write_mudela (self, s):
#        if self.verbatim:
#            self.file.write (s)
			
    def close_mudela (self):
        if self.verbatim:
            self.file.write ('\\end{verbatim}\n')
            self.verbatim = 0
        elif self.charps:
            ps_dim = ps_dimention('%s.ps' % self.mudela_basename)
            print ps_dim
            self.file.write ('\\parbox{%ipt}{\includegraphics{%s.ps}}' % \
                             (ps_dim[0], self.mudela_basename))
        else:
            self.file.write (
            '\\preMudelaExample\\input %s\n\postMudelaExample\n' %(self.mudela_basename))

begin_mudela_re = re.compile ('^ *\\\\begin{mudela}')
begin_mudela_opts_re = re.compile('\[[^\]]*\]')
end_mudela_re = re.compile ('^ *\\\\end{mudela}')
section_re = re.compile ('\\\\section')
chapter_re = re.compile ('\\\\chapter')
#HACK brukes ikke, (eller funker ikke):
input_re = re.compile ('^\\\\input[ \t\n]+\\(.*\\)$')
begin_document_re = re.compile ('^ *\\\\begin{document}')
documentclass_re = re.compile('\\\\documentclass')
twocolumn_re = re.compile('\\\\twocolumn')

class Tex_input:
    def __init__ (self,name):
        if re.search ('\\.[^/\\\\]+',name) == -1:
            name = name + '.tex'
        print 'opening %s' % name
        self.filename = name
        self.infile = open (name)
		
    def get_lines (self):
        lines = self.infile.readlines ()
        (retlines, retdeps) = ([],[self.filename])
        for line in lines:
            if input_re.search (line):
                print "********input"
                s = sys.stdin.read(1)
                t = Tex_input (input_re.group (1))
                ls =t.get_lines ()
                retlines = retlines + ls[0]
                retdeps = retdeps + ls[1]
            else:
                retlines.append (line)

        return (retlines, retdeps)

class Main_tex_input(Tex_input):
    def __init__ (self, name, outname):
		
        Tex_input.__init__ (self, name) # ugh

        self.outname = outname
        self.chapter = 0
        self.section = 0
        self.fine_count =0
        self.mudtex = Tex_output (self.outname)
        self.mudela = None
        self.deps = []
    def set_sections (self, l):
        if section_re.search (l):
            self.section = self.section + 1
        if chapter_re.search (l):
            self.section = 0
            self.chapter = self.chapter + 1

			
    def gulp_mudela (self):
        pass

    def gen_basename (self):
        return '%s/%s-%d.%d.%d' % (outdir, self.outname,self.chapter,self.section,self.fine_count)
    def extract_papersize(self, s):
        opt_s = re.compile('\[[^\]]*\]').search(s)
        if not opt_s:
            return default_paper_size_global
        
        opt_v = re.compile('[ ,]*').split(opt_s.group()[1:][:-1])
        paper_size = None
        for opt in opt_v:
            s = re.compile('(\w*)paper').search(opt)
            if s:
                return s.groups()[0]
        return default_paper_size_global
    def do_it(self):
        (lines, self.deps) = self.get_lines ()
        for line in lines:
            if documentclass_re.search (line):
                print "Har funnet documentclass"
                s = string.split (line, '\\documentclass')[-1]
                reg = re.compile ('\[.*\]')
                print "papersize=", self.extract_papersize (s)
                Paper.set_papersize (self.extract_papersize (s) )
            elif twocolumn_re.search (line):
                Paper.twocolumn ()
#                print "*twocol"
#                sys.stdin.read(1)
            elif begin_document_re.search (line):
                self.mudtex.write ('\\def\\preMudelaExample{}\n')
                self.mudtex.write ('\\def\\postMudelaExample{}\n')
            elif begin_mudela_re.search (line):
                r  = begin_mudela_opts_re.search(line)
                if r:
                    o = r.group()[1:][:-1]
                    optlist =  re.compile('[ ,]*').split(o)
                else:
                    optlist = []
                # Hvis det er verbatim, s skapes det ikke en Mudela_output
                if 'verbatim' in optlist:
                    self.mudtex.open_verbatim ()
                else:
                    self.mudela = Mudela_output ()
                    if force_mudela_fontsize_b:
                        self.mudela.size = fontsize_pt2i[default_mudela_fontsize]
                    else:
                        for pt in fontsize_pt2i.keys():
                            if pt in optlist:
                                self.mudela.size = fontsize_pt2i[pt]
                    b = self.gen_basename ()
                    if 'fragment' in optlist:
                        self.mudela.fragment = 1
                    if 'charps' in optlist:
                        self.mudela.open_to_create_ps (b)
                        self.mudtex.open_to_include_ps (b)
                    else:
                        self.mudela.open (b)
                        self.mudtex.open_mudela (b)
                continue
            elif end_mudela_re.search (line):
                if not self.mudtex.verbatim:
                    self.mudela.close ()
                    self.mudela = None
                    self.fine_count = self.fine_count + 1
                self.mudtex.close_mudela ()
                continue
            # om man for yeblikket leser linjer som er inne i en mudela-
            # definisjon som skal printes, dvs ikke er verbatim, s er
            # self.mudela definert, og da skal det bare skrives til mudela-
            # filen.
            if self.mudela:
                self.mudela.write (line)
#                self.mudtex.write_mudela (line)
            else:
                self.mudtex.write (line)
                self.set_sections(line)
        del self.mudtex
		

def help():
    sys.stdout.write("Usage: mudela-book [options] FILE\n"
		 + "Generate hybrid LaTeX input from Latex + mudela"
		 + "Options:\n"
		 + "  -h, --help             print this help\n"
		 + "  -d, --outdir=DIR       prefix directory\n" 
		 + "  -o, --outname=FILE     prefix for filenames\n"
                 + "  --mudela-fontsize=??pt default fontsize when no parameter for \\begin{mudela}\n"
                 + "  --force-mudela-fontsize=??pt force fontsize for all inline mudela\n"
		     )
    sys.exit (0)


def write_deps (fn, out,  deps):
	out_fn = outdir + '/' + fn
	print '\`writing \`%s\'\n\'' % out_fn
	
	f = open (out_fn, 'w')
	f.write ('%s: %s\n'% (outdir + '/' + out + '.dvi',
			      reduce (lambda x,y: x + ' '+ y, deps)))
	f.close ()

def identify():
    sys.stderr.write('*** Lokal versjon av mudela-book ***\n')
    sys.stderr.write ('This is %s version %s\n' % ('mudela-book', program_version))

def main():
    global default_mudela_fontsize
    outname = ''
    try:
        (options, files) = getopt.getopt(
            sys.argv[1:], 'hd:o:', ['outdir=', 'outname=', 'mudela-fontsize=',
                                    'force-mudela-fontsize=', 'help', 'dependencies'])
    except getopt.error, msg:
        print "error:", msg
        sys.exit(1)
        
    do_deps = 0
    for opt in options:
	o = opt[0]
	a = opt[1]
	if o == '--outname' or o == '-o':
            outname = a
        if o == '--outdir' or o == '-d':
            outdir = a
        if o == '--help' or o == '-h':
            help ()
	if o == '--dependencies':
            do_deps = 1
        if o == '--mudela-fontsize':
            default_mudela_fontsize = a
	if o == '--force-mudela-fontsize':
            default_mudela_fontsize = a
            force_mudela_fontsize_b = 1


        if not fontsize_pt2i.has_key(default_mudela_fontsize):
            print "warning: fontsize %s is not supported using 16pt" % default_mudela_fontsize
            default_mudela_fontsize = '16pt'
    
        for f in files:
            my_outname = outname
            if not my_outname:
		my_outname = regsub.sub ('\\(.*\\)\\.doc', '\\1', f)

            my_depname = my_outname + '.dep'

            inp = Main_tex_input (f, my_outname)
            inp.do_it ()

	if do_deps:
		write_deps (my_depname, my_outname, inp.deps)



identify()
Paper = PaperDef()
main()
